{ -*- buffer-read-only: t -*-

  Copyright 2015-2025 Michalis Kamburelis.

  This file is part of "Castle Game Engine".

  "Castle Game Engine" is free software; see the file COPYING.txt,
  included in this distribution, for details about the copyright.

  "Castle Game Engine" is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

  ----------------------------------------------------------------------------
}

{ Automatically generated node properties.

  Do not edit this file manually!
  To add new properties:
  - add them to the text files in tools/internal/x3d-nodes-to-pascal/nodes-specification/ ,
  - and regenerate include files by running x3d-nodes-to-pascal }

{$ifdef read_interface}

  public
    { Create node fields and events. }
    procedure CreateNode; override;
    class function ClassX3DType: String; override;

    strict private FFdPrograms: TMFNode;
    { Internal wrapper for property @code(Programs). This wrapper API may change, we advise to access simpler @code(Programs) instead, if it is defined (TODO: for now, some field types do not have a simpler counterpart). }
    public property FdPrograms: TMFNode read FFdPrograms;
    {  }
    procedure SetPrograms(const Value: array of TShaderProgramNode);

{$endif read_interface}

{$ifdef read_implementation}

{ TProgramShaderNode ----------------------------------------------- }

procedure TProgramShaderNode.SetPrograms(const Value: array of TShaderProgramNode);
var
  L: Integer;
  A: array of TX3DNode;
begin
  L := High(Value) + 1;
  SetLength(A, L);
  if L > 0 then
    Move(Value[0], A[0], L * SizeOf(TShaderProgramNode));
  FdPrograms.Send(A);
end;

class function TProgramShaderNode.ClassX3DType: String;
begin
  Result := 'ProgramShader';
end;

procedure TProgramShaderNode.CreateNode;
begin
  inherited;

  FFdPrograms := TMFNode.Create(Self, True, 'programs', [TShaderProgramNode]);
   FdPrograms.ChangeAlways := chVisibleNonGeometry;
  AddField(FFdPrograms);
end;

{$endif read_implementation}
