{ -*- buffer-read-only: t -*-

  Copyright 2018-2022 Michalis Kamburelis.

  This file is part of "Castle Game Engine".

  "Castle Game Engine" is free software; see the file COPYING.txt,
  included in this distribution, for details about the copyright.

  "Castle Game Engine" is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

  ----------------------------------------------------------------------------
}

{ Automatically generated wrapper to make vectors/colors persistent.

  Do not edit this file manually!
  Instead
  - edit tools/internal/generate-persistent-vectors/persistent_vectors_input.txt
  - and run generate-persistent-vectors in that directory.
}

{$ifdef read_interface_class}
strict private
  FWorldAnchorPersistent: TCastleVector3Persistent;
  function GetWorldAnchorForPersistent: TVector3;
  procedure SetWorldAnchorForPersistent(const AValue: TVector3);
published
  { @link(WorldAnchor) that can be visually edited in
    Castle Game Engine Editor, Lazarus and Delphi.
    Normal user code does not need to deal with this,
    instead read or write @link(WorldAnchor) directly.

    @seealso WorldAnchor }
  property WorldAnchorPersistent: TCastleVector3Persistent read FWorldAnchorPersistent ;
{$endif read_interface_class}

{$ifdef read_implementation_methods}
function TCastlePulleyJoint.GetWorldAnchorForPersistent: TVector3;
begin
  Result := WorldAnchor;
end;

procedure TCastlePulleyJoint.SetWorldAnchorForPersistent(const AValue: TVector3);
begin
  WorldAnchor := AValue;
end;
{$endif read_implementation_methods}

{$ifdef read_implementation_constructor}
  FWorldAnchorPersistent := TCastleVector3Persistent.Create(nil);
  { Note that some classes (like TCastleVector3Persistent) call SetSubComponent(true)
    on themselves, for backward compatibility. But we should not depend on it,
    some classes (like TFloatRectanglePersisten) may not call it.
    The responsibility of calling "SetSubComponent(true)" should be on the owner
    in general (this is more functional, and more standard too). }
  FWorldAnchorPersistent.SetSubComponent(true);
  FWorldAnchorPersistent.InternalGetValue := {$ifdef FPC}@{$endif}GetWorldAnchorForPersistent;
  FWorldAnchorPersistent.InternalSetValue := {$ifdef FPC}@{$endif}SetWorldAnchorForPersistent;
  FWorldAnchorPersistent.InternalDefaultValue := WorldAnchor; // current value is default
{$endif read_implementation_constructor}

{$ifdef read_implementation_destructor}
  FreeAndNil(FWorldAnchorPersistent);
{$endif read_implementation_destructor}

{ -*- buffer-read-only: t -*-

  Copyright 2018-2022 Michalis Kamburelis.

  This file is part of "Castle Game Engine".

  "Castle Game Engine" is free software; see the file COPYING.txt,
  included in this distribution, for details about the copyright.

  "Castle Game Engine" is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

  ----------------------------------------------------------------------------
}

{ Automatically generated wrapper to make vectors/colors persistent.

  Do not edit this file manually!
  Instead
  - edit tools/internal/generate-persistent-vectors/persistent_vectors_input.txt
  - and run generate-persistent-vectors in that directory.
}

{$ifdef read_interface_class}
strict private
  FConnectedWorldAnchorPersistent: TCastleVector3Persistent;
  function GetConnectedWorldAnchorForPersistent: TVector3;
  procedure SetConnectedWorldAnchorForPersistent(const AValue: TVector3);
published
  { @link(ConnectedWorldAnchor) that can be visually edited in
    Castle Game Engine Editor, Lazarus and Delphi.
    Normal user code does not need to deal with this,
    instead read or write @link(ConnectedWorldAnchor) directly.

    @seealso ConnectedWorldAnchor }
  property ConnectedWorldAnchorPersistent: TCastleVector3Persistent read FConnectedWorldAnchorPersistent ;
{$endif read_interface_class}

{$ifdef read_implementation_methods}
function TCastlePulleyJoint.GetConnectedWorldAnchorForPersistent: TVector3;
begin
  Result := ConnectedWorldAnchor;
end;

procedure TCastlePulleyJoint.SetConnectedWorldAnchorForPersistent(const AValue: TVector3);
begin
  ConnectedWorldAnchor := AValue;
end;
{$endif read_implementation_methods}

{$ifdef read_implementation_constructor}
  FConnectedWorldAnchorPersistent := TCastleVector3Persistent.Create(nil);
  { Note that some classes (like TCastleVector3Persistent) call SetSubComponent(true)
    on themselves, for backward compatibility. But we should not depend on it,
    some classes (like TFloatRectanglePersisten) may not call it.
    The responsibility of calling "SetSubComponent(true)" should be on the owner
    in general (this is more functional, and more standard too). }
  FConnectedWorldAnchorPersistent.SetSubComponent(true);
  FConnectedWorldAnchorPersistent.InternalGetValue := {$ifdef FPC}@{$endif}GetConnectedWorldAnchorForPersistent;
  FConnectedWorldAnchorPersistent.InternalSetValue := {$ifdef FPC}@{$endif}SetConnectedWorldAnchorForPersistent;
  FConnectedWorldAnchorPersistent.InternalDefaultValue := ConnectedWorldAnchor; // current value is default
{$endif read_implementation_constructor}

{$ifdef read_implementation_destructor}
  FreeAndNil(FConnectedWorldAnchorPersistent);
{$endif read_implementation_destructor}

{ -*- buffer-read-only: t -*-

  Copyright 2018-2022 Michalis Kamburelis.

  This file is part of "Castle Game Engine".

  "Castle Game Engine" is free software; see the file COPYING.txt,
  included in this distribution, for details about the copyright.

  "Castle Game Engine" is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

  ----------------------------------------------------------------------------
}

{ Automatically generated wrapper to make vectors/colors persistent.

  Do not edit this file manually!
  Instead
  - edit tools/internal/generate-persistent-vectors/persistent_vectors_input.txt
  - and run generate-persistent-vectors in that directory.
}

{$ifdef read_interface_class}
strict private
  FWorldGroundAnchorPersistent: TCastleVector3Persistent;
  function GetWorldGroundAnchorForPersistent: TVector3;
  procedure SetWorldGroundAnchorForPersistent(const AValue: TVector3);
published
  { @link(WorldGroundAnchor) that can be visually edited in
    Castle Game Engine Editor, Lazarus and Delphi.
    Normal user code does not need to deal with this,
    instead read or write @link(WorldGroundAnchor) directly.

    @seealso WorldGroundAnchor }
  property WorldGroundAnchorPersistent: TCastleVector3Persistent read FWorldGroundAnchorPersistent ;
{$endif read_interface_class}

{$ifdef read_implementation_methods}
function TCastlePulleyJoint.GetWorldGroundAnchorForPersistent: TVector3;
begin
  Result := WorldGroundAnchor;
end;

procedure TCastlePulleyJoint.SetWorldGroundAnchorForPersistent(const AValue: TVector3);
begin
  WorldGroundAnchor := AValue;
end;
{$endif read_implementation_methods}

{$ifdef read_implementation_constructor}
  FWorldGroundAnchorPersistent := TCastleVector3Persistent.Create(nil);
  { Note that some classes (like TCastleVector3Persistent) call SetSubComponent(true)
    on themselves, for backward compatibility. But we should not depend on it,
    some classes (like TFloatRectanglePersisten) may not call it.
    The responsibility of calling "SetSubComponent(true)" should be on the owner
    in general (this is more functional, and more standard too). }
  FWorldGroundAnchorPersistent.SetSubComponent(true);
  FWorldGroundAnchorPersistent.InternalGetValue := {$ifdef FPC}@{$endif}GetWorldGroundAnchorForPersistent;
  FWorldGroundAnchorPersistent.InternalSetValue := {$ifdef FPC}@{$endif}SetWorldGroundAnchorForPersistent;
  FWorldGroundAnchorPersistent.InternalDefaultValue := WorldGroundAnchor; // current value is default
{$endif read_implementation_constructor}

{$ifdef read_implementation_destructor}
  FreeAndNil(FWorldGroundAnchorPersistent);
{$endif read_implementation_destructor}

{ -*- buffer-read-only: t -*-

  Copyright 2018-2022 Michalis Kamburelis.

  This file is part of "Castle Game Engine".

  "Castle Game Engine" is free software; see the file COPYING.txt,
  included in this distribution, for details about the copyright.

  "Castle Game Engine" is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

  ----------------------------------------------------------------------------
}

{ Automatically generated wrapper to make vectors/colors persistent.

  Do not edit this file manually!
  Instead
  - edit tools/internal/generate-persistent-vectors/persistent_vectors_input.txt
  - and run generate-persistent-vectors in that directory.
}

{$ifdef read_interface_class}
strict private
  FConnectedWorldGroundAnchorPersistent: TCastleVector3Persistent;
  function GetConnectedWorldGroundAnchorForPersistent: TVector3;
  procedure SetConnectedWorldGroundAnchorForPersistent(const AValue: TVector3);
published
  { @link(ConnectedWorldGroundAnchor) that can be visually edited in
    Castle Game Engine Editor, Lazarus and Delphi.
    Normal user code does not need to deal with this,
    instead read or write @link(ConnectedWorldGroundAnchor) directly.

    @seealso ConnectedWorldGroundAnchor }
  property ConnectedWorldGroundAnchorPersistent: TCastleVector3Persistent read FConnectedWorldGroundAnchorPersistent ;
{$endif read_interface_class}

{$ifdef read_implementation_methods}
function TCastlePulleyJoint.GetConnectedWorldGroundAnchorForPersistent: TVector3;
begin
  Result := ConnectedWorldGroundAnchor;
end;

procedure TCastlePulleyJoint.SetConnectedWorldGroundAnchorForPersistent(const AValue: TVector3);
begin
  ConnectedWorldGroundAnchor := AValue;
end;
{$endif read_implementation_methods}

{$ifdef read_implementation_constructor}
  FConnectedWorldGroundAnchorPersistent := TCastleVector3Persistent.Create(nil);
  { Note that some classes (like TCastleVector3Persistent) call SetSubComponent(true)
    on themselves, for backward compatibility. But we should not depend on it,
    some classes (like TFloatRectanglePersisten) may not call it.
    The responsibility of calling "SetSubComponent(true)" should be on the owner
    in general (this is more functional, and more standard too). }
  FConnectedWorldGroundAnchorPersistent.SetSubComponent(true);
  FConnectedWorldGroundAnchorPersistent.InternalGetValue := {$ifdef FPC}@{$endif}GetConnectedWorldGroundAnchorForPersistent;
  FConnectedWorldGroundAnchorPersistent.InternalSetValue := {$ifdef FPC}@{$endif}SetConnectedWorldGroundAnchorForPersistent;
  FConnectedWorldGroundAnchorPersistent.InternalDefaultValue := ConnectedWorldGroundAnchor; // current value is default
{$endif read_implementation_constructor}

{$ifdef read_implementation_destructor}
  FreeAndNil(FConnectedWorldGroundAnchorPersistent);
{$endif read_implementation_destructor}

