{ -*- buffer-read-only: t -*-

  Copyright 2018-2022 Michalis Kamburelis.

  This file is part of "Castle Game Engine".

  "Castle Game Engine" is free software; see the file COPYING.txt,
  included in this distribution, for details about the copyright.

  "Castle Game Engine" is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

  ----------------------------------------------------------------------------
}

{ Automatically generated wrapper to make vectors/colors persistent.

  Do not edit this file manually!
  Instead
  - edit tools/internal/generate-persistent-vectors/persistent_vectors_input.txt
  - and run generate-persistent-vectors in that directory.
}

{$ifdef read_interface_class}
strict private
  FAngularVelocityPersistent: TCastleVector3Persistent;
  function GetAngularVelocityForPersistent: TVector3;
  procedure SetAngularVelocityForPersistent(const AValue: TVector3);
published
  { @link(AngularVelocity) that can be visually edited in
    Castle Game Engine Editor, Lazarus and Delphi.
    Normal user code does not need to deal with this,
    instead read or write @link(AngularVelocity) directly.

    @seealso AngularVelocity }
  property AngularVelocityPersistent: TCastleVector3Persistent read FAngularVelocityPersistent ;
{$endif read_interface_class}

{$ifdef read_implementation_methods}
function TCastleRigidBody.GetAngularVelocityForPersistent: TVector3;
begin
  Result := AngularVelocity;
end;

procedure TCastleRigidBody.SetAngularVelocityForPersistent(const AValue: TVector3);
begin
  AngularVelocity := AValue;
end;
{$endif read_implementation_methods}

{$ifdef read_implementation_constructor}
  FAngularVelocityPersistent := TCastleVector3Persistent.Create(nil);
  { Note that some classes (like TCastleVector3Persistent) call SetSubComponent(true)
    on themselves, for backward compatibility. But we should not depend on it,
    some classes (like TFloatRectanglePersisten) may not call it.
    The responsibility of calling "SetSubComponent(true)" should be on the owner
    in general (this is more functional, and more standard too). }
  FAngularVelocityPersistent.SetSubComponent(true);
  FAngularVelocityPersistent.InternalGetValue := {$ifdef FPC}@{$endif}GetAngularVelocityForPersistent;
  FAngularVelocityPersistent.InternalSetValue := {$ifdef FPC}@{$endif}SetAngularVelocityForPersistent;
  FAngularVelocityPersistent.InternalDefaultValue := AngularVelocity; // current value is default
{$endif read_implementation_constructor}

{$ifdef read_implementation_destructor}
  FreeAndNil(FAngularVelocityPersistent);
{$endif read_implementation_destructor}

{ -*- buffer-read-only: t -*-

  Copyright 2018-2022 Michalis Kamburelis.

  This file is part of "Castle Game Engine".

  "Castle Game Engine" is free software; see the file COPYING.txt,
  included in this distribution, for details about the copyright.

  "Castle Game Engine" is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

  ----------------------------------------------------------------------------
}

{ Automatically generated wrapper to make vectors/colors persistent.

  Do not edit this file manually!
  Instead
  - edit tools/internal/generate-persistent-vectors/persistent_vectors_input.txt
  - and run generate-persistent-vectors in that directory.
}

{$ifdef read_interface_class}
strict private
  FLinearVelocityPersistent: TCastleVector3Persistent;
  function GetLinearVelocityForPersistent: TVector3;
  procedure SetLinearVelocityForPersistent(const AValue: TVector3);
published
  { @link(LinearVelocity) that can be visually edited in
    Castle Game Engine Editor, Lazarus and Delphi.
    Normal user code does not need to deal with this,
    instead read or write @link(LinearVelocity) directly.

    @seealso LinearVelocity }
  property LinearVelocityPersistent: TCastleVector3Persistent read FLinearVelocityPersistent ;
{$endif read_interface_class}

{$ifdef read_implementation_methods}
function TCastleRigidBody.GetLinearVelocityForPersistent: TVector3;
begin
  Result := LinearVelocity;
end;

procedure TCastleRigidBody.SetLinearVelocityForPersistent(const AValue: TVector3);
begin
  LinearVelocity := AValue;
end;
{$endif read_implementation_methods}

{$ifdef read_implementation_constructor}
  FLinearVelocityPersistent := TCastleVector3Persistent.Create(nil);
  { Note that some classes (like TCastleVector3Persistent) call SetSubComponent(true)
    on themselves, for backward compatibility. But we should not depend on it,
    some classes (like TFloatRectanglePersisten) may not call it.
    The responsibility of calling "SetSubComponent(true)" should be on the owner
    in general (this is more functional, and more standard too). }
  FLinearVelocityPersistent.SetSubComponent(true);
  FLinearVelocityPersistent.InternalGetValue := {$ifdef FPC}@{$endif}GetLinearVelocityForPersistent;
  FLinearVelocityPersistent.InternalSetValue := {$ifdef FPC}@{$endif}SetLinearVelocityForPersistent;
  FLinearVelocityPersistent.InternalDefaultValue := LinearVelocity; // current value is default
{$endif read_implementation_constructor}

{$ifdef read_implementation_destructor}
  FreeAndNil(FLinearVelocityPersistent);
{$endif read_implementation_destructor}

